/**
 * Copyright 2019-2021 Britanicus <marcusbritanicus@gmail.com>
 *
 * This file is a part of DesQ Shell (https://gitlab.com/DesQ/Shell)
 * DesQ Shell is the main Shell UI of the DesQ Project
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * at your option, any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 **/

#pragma once

#include "Global.hpp"
#include <desq/Xdg.hpp>
#include <desq/Utils.hpp>

namespace DesQ {
    namespace Menu {
        class CategoryView;
        class FavoritesView;
    }
}

class DesQ::Menu::CategoryView : public QListWidget {
    Q_OBJECT;

    public:
        CategoryView( QWidget *parent );
        void setCategories( QStringList );

    protected:
        void mouseReleaseEvent( QMouseEvent *mEvent );
        void keyPressEvent( QKeyEvent * );

    Q_SIGNALS:
        void closeMenu();
        void loadCategory( QString );

        void focusSearch();
};

class DesQ::Menu::FavoritesView : public QListWidget {
    Q_OBJECT;

    public:
        FavoritesView( QWidget *parent );

    protected:
        void mouseReleaseEvent( QMouseEvent *mEvent );
        void keyPressEvent( QKeyEvent * );

        void focusInEvent( QFocusEvent * );
        void focusOutEvent( QFocusEvent * );

    Q_SIGNALS:
        void closeMenu();

        void focusSearch();
};
